'''Created 16 Nov 2022 Levi'''

import asyncio

import mail_alert

async def main() -> None:
    container: set = set()
    try:
        while True:
            tasks = [mail_alert.mail_alert(container),
                     mail_alert.mail_alert2(container),
                     mail_alert.mail_alert3(container)]
            # result = await asyncio.wait(tasks)
            results = await asyncio.gather(*tasks)
            print(results)
            for result in results:
                for id_ in result:
                    if id_ not in container:
                        container.add(id_)
            # await asyncio.sleep(1)
    except KeyboardInterrupt:
        print('Cancelling all tasks...')
        for task in tasks:
            task.cancel() # noqa
        await asyncio.gather(*tasks, return_exceptions=True)
        print('All tasks cancelled.')

if __name__ == '__main__':
    asyncio.run(main())
